{{
  QS_IR_Remote.spin      Richard Lamb 2 Nov 2012
  IR_Remote_NewCog.spin  Tom Doyle  2 March 2007

      IR remote control lights up the appropriate LED.
      Numbers 7 through 8
      CH^ increments LED, CHv Decrements LED
      Vol< and VOL> work backwards so the LEDs go in the same direction as the buttons.
      Vol and CH both wrap around.
      PWR runs chase and forth once.
      OK short blinks all LEDs LED+1 times.
}}
CON
  _CLKMODE = XTAL1 + PLL16X        ' 80 Mhz clock
  _XINFREQ = 5_000_000
  IRdetPin  =    2                   ' IR Receiver - Propeller Pin
  BlinkPin  = 16                     ' Proof of life
    
OBJ
  ir    : "IR_Remote"

VAR
  byte IRcode , LED,  IVcode, X
  LONG MS001, Twait 
  
PUB Init | freq, index, cog, lcode
  Twait := ClkFREQ  /3 ' / 20  '/3 for slo-mo   
  MS001 := CLKFREQ / 1_000    ' define count for 1 millisec
  outa[ 16..23 ] := $00       ' all LED pins off    '
  dira[ 16..23 ] := $FF       ' all LED pins outputs   '
  LED := 6
  LEDON(LED)
  cog := ir.Start(IRdetPin, @IRcode)  ' Propeller pin connected to the IR receiver, address of variable
  if cog > 0
     repeat
        If IRcode <> ir#NoNewCode
          lcode := IRcode
          ir.Start(IRdetPin, @IRcode)  ' set up for next code
          case lcode
'Numbers          
            ir#zero  :          'ignore
                        
            ir#one   :
              LED := Lcode              
            
            ir#two   :
              LED := Lcode            
              
            ir#three :
              LED := Lcode            
                                      
            ir#four  :
              LED := Lcode            
                          
            ir#five  :
              LED := Lcode            
            
            ir#six   :
              LED := Lcode            
            
            ir#seven :
              LED := Lcode              
            
            ir#eight :
              LED := Lcode             

            ir#nine  :           'ignore 
              
'-----------------------------------------------------
'Channel
            ir#chUp  :
             'pst.str(string("chUp "))
              repeat  4
                outa [16..23] := 0
                outa [16..23] := %11111111
                waitMS(101)    
                 
            ir#chDn  :
             'pst.str(string("chDn "))
              repeat  2
                outa [16..23] := 0
                outa [16..23] := %11111111
                waitMS(101)    
'Volumn
            ir#volUp :
             'pst.str(string("volUp"))
              if LED > 0
                 LED--
              else
                 LED := 7

            ir#volDn :
             'pst.str(string("volDn"))
              if LED < 7
                 LED++
              else              ' wrap around
                 LED := 0

            ir#ok  :
             'pst.str(string("ok   "))

              repeat  LED +1
                outa [16..23] := 0
                outa [16..23] := %11111111
                waitMS(101)
                outa [16..23] := 0                              
                waitMS(180)

                
            ir#power :
             'pst.str(string("power"))
              X := LED
              Twait := ClkFREQ / 20  '/3 for slo-mo   
              dira[16..23] := %11111111
              outa[16..23] := 0
              repeat 1
                  repeat  Led FROM 16 to 23
                     outa[LED..LED-2] := %111
                     WaitCnt(Twait+cnt)
                     outa[Led-2]  := 0
                     WaitCnt(Twait+cnt)
                     outa [LED-1] := 0
                     WaitCnt(Twait+cnt)
                  repeat  Led FROM 23 to 16
                     outa[LED..LED+2] := %111
                     WaitCnt(Twait+cnt)
                     outa[Led+2] := 0
                     waitCnt (Twait+cnt)
                     outa [LED+1] := 0
                     WaitCnt(Twait+cnt)
              LED := X
              
        LEDON(LED)
        
 
PRI LEDON(n)
   outa [16..23] := 0
   outa [16+n]:= 1

PRI LEDOFF(n)
   outa [16..32] := 0
   
PUB WaitMS(W)                      'wait for W milliseconds
  W := W * MS001                
  WaitCNT (W+cnt)